Imports System.ComponentModel


Public Class TypedListWrapperIBindingList
    Inherits TypedListWrapperIList
    Implements IBindingList

    Public Sub New()

    End Sub

    Public Sub New(ByVal wrappedIBindingList As IBindingList)
        _wrappedIBindingList = wrappedIBindingList
    End Sub

    Public Sub New(ByVal wrappedIBindingList As IBindingList, ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
        _wrappedIBindingList = wrappedIBindingList
    End Sub

    Public Sub New(ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
    End Sub

    Private _wrappedIBindingList As IBindingList
    Public Property WrappedIBindingList() As IBindingList
        Get
            Return _wrappedIBindingList
        End Get
        Set(ByVal Value As IBindingList)
            _wrappedIBindingList = Value
        End Set
    End Property

    Private Sub IBindingList_AddIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.AddIndex
        _wrappedIBindingList.AddIndex([property])
    End Sub

    Private Function IBindingList_AddNew() As Object Implements System.ComponentModel.IBindingList.AddNew
        Return _wrappedIBindingList.AddNew
    End Function

    Private ReadOnly Property IBindingList_AllowEdit() As Boolean Implements System.ComponentModel.IBindingList.AllowEdit
        Get
            Return _wrappedIBindingList.AllowEdit
        End Get
    End Property

    Private ReadOnly Property IBindingList_AllowNew() As Boolean Implements System.ComponentModel.IBindingList.AllowNew
        Get
            Return _wrappedIBindingList.AllowNew
        End Get
    End Property

    Private ReadOnly Property IBindingList_AllowRemove() As Boolean Implements System.ComponentModel.IBindingList.AllowRemove
        Get
            Return _wrappedIBindingList.AllowRemove
        End Get
    End Property

    Private Sub IBindingList_ApplySort(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal direction As System.ComponentModel.ListSortDirection) Implements System.ComponentModel.IBindingList.ApplySort
        _wrappedIBindingList.ApplySort([property], direction)
    End Sub

    Private Function IBindingList_Find(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal key As Object) As Integer Implements System.ComponentModel.IBindingList.Find
        Return _wrappedIBindingList.Find([property], key)
    End Function

    Private ReadOnly Property IBindingList_IsSorted() As Boolean Implements System.ComponentModel.IBindingList.IsSorted
        Get
            Return _wrappedIBindingList.IsSorted
        End Get
    End Property

    Private Custom Event IBindingList_ListChanged As ListChangedEventHandler Implements System.ComponentModel.IBindingList.ListChanged
        AddHandler(ByVal value As ListChangedEventHandler)
            AddHandler CType(_wrappedIBindingList, IBindingList).ListChanged, value
        End AddHandler

        RemoveHandler(ByVal value As ListChangedEventHandler)
            RemoveHandler CType(_wrappedIBindingList, IBindingList).ListChanged, value
        End RemoveHandler

        RaiseEvent(ByVal sender As Object, ByVal e As System.ComponentModel.ListChangedEventArgs)

        End RaiseEvent
    End Event

    Private Sub IBindingList_RemoveIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.RemoveIndex
        _wrappedIBindingList.RemoveIndex([property])
    End Sub

    Private Sub IBindingList_RemoveSort() Implements System.ComponentModel.IBindingList.RemoveSort
        _wrappedIBindingList.RemoveSort()
    End Sub

    Private ReadOnly Property IBindingList_SortDirection() As System.ComponentModel.ListSortDirection Implements System.ComponentModel.IBindingList.SortDirection
        Get
            Return _wrappedIBindingList.SortDirection
        End Get
    End Property

    Private ReadOnly Property IBindingList_SortProperty() As System.ComponentModel.PropertyDescriptor Implements System.ComponentModel.IBindingList.SortProperty
        Get
            Return _wrappedIBindingList.SortProperty
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsChangeNotification() As Boolean Implements System.ComponentModel.IBindingList.SupportsChangeNotification
        Get
            Return _wrappedIBindingList.SupportsChangeNotification
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsSearching() As Boolean Implements System.ComponentModel.IBindingList.SupportsSearching
        Get
            Return _wrappedIBindingList.SupportsSearching
        End Get
    End Property

    Private ReadOnly Property IBindingList_SupportsSorting() As Boolean Implements System.ComponentModel.IBindingList.SupportsSorting
        Get
            Return _wrappedIBindingList.SupportsSorting
        End Get
    End Property
End Class