Imports System.ComponentModel

Public Class TypedListWrapperIList
    Inherits TypedListWrapper
    Implements IList

    Public Sub New()

    End Sub

    Public Sub New(ByVal wrappedIList As IList)
        _wrappedIList = wrappedIList
    End Sub

    Public Sub New(ByVal wrappedIList As IList, ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
        _wrappedIList = wrappedIList
    End Sub

    Public Sub New(ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
    End Sub

    Private _wrappedIList As IList
    Public Property WrappedIList() As IList
        Get
            Return _wrappedIList
        End Get
        Set(ByVal Value As IList)
            _wrappedIList = Value
        End Set
    End Property

    Private Sub ICollection_CopyTo(ByVal array As System.Array, ByVal index As Integer) Implements System.Collections.ICollection.CopyTo
        _wrappedIList.CopyTo(array, index)
    End Sub

    Private ReadOnly Property ICollection_Count() As Integer Implements System.Collections.ICollection.Count
        Get
            Return _wrappedIList.Count
        End Get
    End Property

    Private ReadOnly Property ICollection_IsSynchronized() As Boolean Implements System.Collections.ICollection.IsSynchronized
        Get
            Return _wrappedIList.IsSynchronized
        End Get
    End Property

    Private ReadOnly Property ICollection_SyncRoot() As Object Implements System.Collections.ICollection.SyncRoot
        Get
            Return _wrappedIList.SyncRoot
        End Get
    End Property

    Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return _wrappedIList.GetEnumerator
    End Function

    Private Function IList_Add(ByVal value As Object) As Integer Implements System.Collections.IList.Add
        Return _wrappedIList.Add(value)
    End Function

    Private Sub IList_Clear() Implements System.Collections.IList.Clear
        _wrappedIList.Clear()
    End Sub

    Private Function IList_Contains(ByVal value As Object) As Boolean Implements System.Collections.IList.Contains
        Return _wrappedIList.Contains(value)
    End Function

    Private Function IList_IndexOf(ByVal value As Object) As Integer Implements System.Collections.IList.IndexOf
        Return _wrappedIList.IndexOf(value)
    End Function

    Private Sub IList_Insert(ByVal index As Integer, ByVal value As Object) Implements System.Collections.IList.Insert
        _wrappedIList.Insert(index, value)
    End Sub

    Private ReadOnly Property IList_IsFixedSize() As Boolean Implements System.Collections.IList.IsFixedSize
        Get
            Return _wrappedIList.IsFixedSize
        End Get
    End Property

    Private ReadOnly Property IList_IsReadOnly() As Boolean Implements System.Collections.IList.IsReadOnly
        Get
            Return _wrappedIList.IsReadOnly
        End Get
    End Property

    Private Property IList_Item(ByVal index As Integer) As Object Implements System.Collections.IList.Item
        Get
            Return _wrappedIList.Item(index)
        End Get
        Set(ByVal value As Object)
            _wrappedIList.Item(index) = value
        End Set
    End Property

    Private Sub IList_Remove(ByVal value As Object) Implements System.Collections.IList.Remove
        _wrappedIList.Remove(value)
    End Sub

    Private Sub IList_RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
        _wrappedIList.RemoveAt(index)
    End Sub
End Class
