
Public Class CountryInfoList
    Inherits System.ComponentModel.Component
    Implements IList(Of CountryInfo), IList

    Private _innerList As List(Of CountryInfo)

    Public Sub New()
        _innerList = New List(Of CountryInfo)

        _innerList.Add(New CountryInfo("Afghanistan", 647500, 29929000))
        _innerList.Add(New CountryInfo("Albania", 28748, 3563100))
        _innerList.Add(New CountryInfo("Algeria", 2381740, 32531900))
        _innerList.Add(New CountryInfo("American Samoa", 199, 57880))
        _innerList.Add(New CountryInfo("Andorra", 468, 70550))
        _innerList.Add(New CountryInfo("Angola", 1246700, 11190800))
        _innerList.Add(New CountryInfo("Anguilla", 102, 13250))
        _innerList.Add(New CountryInfo("Antigua & Barbuda", 443, 68720))
        _innerList.Add(New CountryInfo("Argentina", 2766890, 39537900))
        _innerList.Add(New CountryInfo("Armenia", 29800, 2982900))
        _innerList.Add(New CountryInfo("Aruba", 193, 71570))
        _innerList.Add(New CountryInfo("Australia", 7686850, 20090400))
        _innerList.Add(New CountryInfo("Austria", 83858, 8184700))
        _innerList.Add(New CountryInfo("Azerbaijan", 86600, 7912000))
        _innerList.Add(New CountryInfo("Bahamas", 13940, 301800))
        _innerList.Add(New CountryInfo("Bahrain", 665, 688300))
        _innerList.Add(New CountryInfo("Bangladesh", 144000, 144319600))
        _innerList.Add(New CountryInfo("Barbados", 431, 279300))
        _innerList.Add(New CountryInfo("Belarus", 207600, 10300500))
        _innerList.Add(New CountryInfo("Belgium", 30510, 10364400))
        _innerList.Add(New CountryInfo("Belize", 22966, 279500))
        _innerList.Add(New CountryInfo("Benin", 112620, 7460000))
        _innerList.Add(New CountryInfo("Bermuda", 53, 65370))
        _innerList.Add(New CountryInfo("Bhutan", 47000, 2232300))
        _innerList.Add(New CountryInfo("Bolivia", 1098580, 8857900))
        _innerList.Add(New CountryInfo("Bosnia & Herzegovina", 51129, 4025500))
        _innerList.Add(New CountryInfo("Botswana", 600370, 1640100))
        _innerList.Add(New CountryInfo("Brazil", 8511965, 186112800))
        _innerList.Add(New CountryInfo("British Virgin Islands", 153, 22640))
        _innerList.Add(New CountryInfo("Brunei", 5770, 372400))
        _innerList.Add(New CountryInfo("Bulgaria", 110910, 7450300))
        _innerList.Add(New CountryInfo("Burkina Faso", 274200, 13925300))
        _innerList.Add(New CountryInfo("Burundi", 27830, 6370600))
        _innerList.Add(New CountryInfo("Cambodia", 181040, 13607100))
        _innerList.Add(New CountryInfo("Cameroon", 475440, 16380000))
        _innerList.Add(New CountryInfo("Canada", 9976140, 32805000))
        _innerList.Add(New CountryInfo("Cape Verde", 4033, 418200))
        _innerList.Add(New CountryInfo("Cayman Islands", 262, 44270))
        _innerList.Add(New CountryInfo("Central African Republic", 622984, 3799900))
        _innerList.Add(New CountryInfo("Chad", 1284000, 9826400))
        _innerList.Add(New CountryInfo("Chile", 756950, 15980900))
        _innerList.Add(New CountryInfo("China", 9596960, 1306313800))
        _innerList.Add(New CountryInfo("Colombia", 1138910, 42954300))
        _innerList.Add(New CountryInfo("Comoros", 2170, 671200))
        _innerList.Add(New CountryInfo("Congo (Dem. Rep.)", 2345410, 60085800))
        _innerList.Add(New CountryInfo("Congo (Rep.)", 342000, 3039100))
        _innerList.Add(New CountryInfo("Cook Islands", 240, 21390))
        _innerList.Add(New CountryInfo("Costa Rica", 51100, 4016200))
        _innerList.Add(New CountryInfo("Cote d'Ivoire", 322460, 17298000))
        _innerList.Add(New CountryInfo("Croatia", 56542, 4495900))
        _innerList.Add(New CountryInfo("Cuba", 110860, 11346700))
        _innerList.Add(New CountryInfo("Cyprus", 9250, 780100))
        _innerList.Add(New CountryInfo("Czech Republic", 78866, 10241100))
        _innerList.Add(New CountryInfo("Denmark", 43094, 5432300))
        _innerList.Add(New CountryInfo("Djibouti", 23000, 476700))
        _innerList.Add(New CountryInfo("Dominica", 754, 69030))
        _innerList.Add(New CountryInfo("Dominican Republic", 48730, 8950000))
        _innerList.Add(New CountryInfo("East Timor", 15007, 1040900))
        _innerList.Add(New CountryInfo("Ecuador", 283560, 13363600))
        _innerList.Add(New CountryInfo("Egypt", 1001450, 77505800))
        _innerList.Add(New CountryInfo("El Salvador", 21040, 6704900))
        _innerList.Add(New CountryInfo("Equatorial Guinea", 28051, 535900))
        _innerList.Add(New CountryInfo("Eritrea", 121320, 4561600))
        _innerList.Add(New CountryInfo("Estonia", 45226, 1332900))
        _innerList.Add(New CountryInfo("Ethiopia", 1127127, 73053300))
        _innerList.Add(New CountryInfo("Falkland Islands", 12173, 2970))
        _innerList.Add(New CountryInfo("Faroe Islands", 1399, 46960))
        _innerList.Add(New CountryInfo("Fiji", 18270, 893400))
        _innerList.Add(New CountryInfo("Finland", 337030, 5223400))
        _innerList.Add(New CountryInfo("France", 547030, 60656200))
        _innerList.Add(New CountryInfo("French Guiana", 91000, 195500))
        _innerList.Add(New CountryInfo("French Polynesia", 4167, 270500))
        _innerList.Add(New CountryInfo("Gabon", 267667, 1389200))
        _innerList.Add(New CountryInfo("Gambia", 11300, 1593300))
        _innerList.Add(New CountryInfo("Georgia", 69700, 4677400))
        _innerList.Add(New CountryInfo("Germany", 357021, 82431400))
        _innerList.Add(New CountryInfo("Ghana", 239460, 21029900))
        _innerList.Add(New CountryInfo("Gibraltar", 6, 27880))
        _innerList.Add(New CountryInfo("Great Britain (and Northern Ireland)", 244820, 60441500))
        _innerList.Add(New CountryInfo("Greece", 131940, 10668400))
        _innerList.Add(New CountryInfo("Greenland", 2166086, 56380))
        _innerList.Add(New CountryInfo("Grenada", 344, 89500))
        _innerList.Add(New CountryInfo("Guadeloupe", 1780, 448700))
        _innerList.Add(New CountryInfo("Guam", 549, 168600))
        _innerList.Add(New CountryInfo("Guatemala", 108890, 14655200))
        _innerList.Add(New CountryInfo("Guernsey", 78, 65230))
        _innerList.Add(New CountryInfo("Guinea", 245857, 9467900))
        _innerList.Add(New CountryInfo("Guinea-Bissau", 36120, 1416000))
        _innerList.Add(New CountryInfo("Guyana", 214970, 765300))
        _innerList.Add(New CountryInfo("Haiti", 27750, 8121600))
        _innerList.Add(New CountryInfo("Honduras", 112090, 6975200))
        _innerList.Add(New CountryInfo("Hong Kong", 1092, 6898700))
        _innerList.Add(New CountryInfo("Hungary", 93030, 10006800))
        _innerList.Add(New CountryInfo("Iceland", 103000, 296700))
        _innerList.Add(New CountryInfo("India", 3287590, 1080264400))
        _innerList.Add(New CountryInfo("Indonesia", 1919440, 241973900))
        _innerList.Add(New CountryInfo("Iran", 1648000, 68017900))
        _innerList.Add(New CountryInfo("Iraq", 437072, 26074900))
        _innerList.Add(New CountryInfo("Ireland", 70280, 4015700))
        _innerList.Add(New CountryInfo("Israel", 20770, 6276900))
        _innerList.Add(New CountryInfo("Italy", 301230, 58103000))
        _innerList.Add(New CountryInfo("Jamaica", 10991, 2731800))
        _innerList.Add(New CountryInfo("Japan", 377835, 127417200))
        _innerList.Add(New CountryInfo("Jersey", 116, 90810))
        _innerList.Add(New CountryInfo("Jordan", 92300, 5759700))
        _innerList.Add(New CountryInfo("Kazakhstan", 2717300, 15185800))
        _innerList.Add(New CountryInfo("Kenya", 582650, 33829600))
        _innerList.Add(New CountryInfo("Kiribati", 811, 103100))
        _innerList.Add(New CountryInfo("Korea (North)", 120540, 22912200))
        _innerList.Add(New CountryInfo("Korea (South)", 98480, 48422600))
        _innerList.Add(New CountryInfo("Kuwait", 17820, 2335600))
        _innerList.Add(New CountryInfo("Kyrgyzstan", 198500, 5146300))
        _innerList.Add(New CountryInfo("Laos", 236800, 6217100))
        _innerList.Add(New CountryInfo("Latvia", 64589, 2290200))
        _innerList.Add(New CountryInfo("Lebanon", 10400, 3826000))
        _innerList.Add(New CountryInfo("Lesotho", 30355, 1867000))
        _innerList.Add(New CountryInfo("Liberia", 111370, 3482200))
        _innerList.Add(New CountryInfo("Libya", 1759540, 5765600))
        _innerList.Add(New CountryInfo("Liechtenstein", 160, 33720))
        _innerList.Add(New CountryInfo("Lithuania", 65200, 3596600))
        _innerList.Add(New CountryInfo("Luxembourg", 2586, 468600))
        _innerList.Add(New CountryInfo("Macau", 25, 449200))
        _innerList.Add(New CountryInfo("Macedonia", 25333, 2045300))
        _innerList.Add(New CountryInfo("Madagascar", 587040, 18040300))
        _innerList.Add(New CountryInfo("Malawi", 118480, 12158900))
        _innerList.Add(New CountryInfo("Malaysia", 329750, 23953100))
        _innerList.Add(New CountryInfo("Maldives", 300, 349100))
        _innerList.Add(New CountryInfo("Mali", 1240000, 12291500))
        _innerList.Add(New CountryInfo("Malta", 316, 398500))
        _innerList.Add(New CountryInfo("Man, Isle of", 572, 75050))
        _innerList.Add(New CountryInfo("Marshall Islands", 181, 59070))
        _innerList.Add(New CountryInfo("Martinique", 1100, 432900))
        _innerList.Add(New CountryInfo("Mauritania", 1030700, 3086900))
        _innerList.Add(New CountryInfo("Mauritius", 2040, 1230600))
        _innerList.Add(New CountryInfo("Mayotte", 374, 193600))
        _innerList.Add(New CountryInfo("Mexico", 1972550, 106202900))
        _innerList.Add(New CountryInfo("Micronesia, Federated States of", 702, 108100))
        _innerList.Add(New CountryInfo("Moldova", 33843, 4455400))
        _innerList.Add(New CountryInfo("Monaco", 2, 32410))
        _innerList.Add(New CountryInfo("Mongolia", 1565000, 2791300))
        _innerList.Add(New CountryInfo("Montserrat", 102, 9340))
        _innerList.Add(New CountryInfo("Morocco", 446550, 32725800))
        _innerList.Add(New CountryInfo("Mozambique", 801590, 19406700))
        _innerList.Add(New CountryInfo("Myanmar", 678500, 42909500))
        _innerList.Add(New CountryInfo("Namibia", 825418, 2030700))
        _innerList.Add(New CountryInfo("Nauru", 21, 13050))
        _innerList.Add(New CountryInfo("Nepal", 140800, 27676500))
        _innerList.Add(New CountryInfo("Netherlands", 41526, 16407500))
        _innerList.Add(New CountryInfo("Netherlands Antilles", 960, 220000))
        _innerList.Add(New CountryInfo("New Caledonia", 19060, 216500))
        _innerList.Add(New CountryInfo("New Zealand", 268680, 4035500))
        _innerList.Add(New CountryInfo("Nicaragua", 129494, 5465100))
        _innerList.Add(New CountryInfo("Niger", 1267000, 11665900))
        _innerList.Add(New CountryInfo("Nigeria", 923768, 128772000))
        _innerList.Add(New CountryInfo("Niue", 260, 2170))
        _innerList.Add(New CountryInfo("Norfolk Island", 35, 1830))
        _innerList.Add(New CountryInfo("Northern Mariana Islands", 477, 80360))
        _innerList.Add(New CountryInfo("Norway", 324220, 4593000))
        _innerList.Add(New CountryInfo("Oman", 212460, 3001600))
        _innerList.Add(New CountryInfo("Pakistan", 803940, 162419900))
        _innerList.Add(New CountryInfo("Palau", 458, 20300))
        _innerList.Add(New CountryInfo("Palestinian Territories", 6220, 3761900))
        _innerList.Add(New CountryInfo("Panama", 78200, 3039200))
        _innerList.Add(New CountryInfo("Papua New Guinea", 462840, 5545300))
        _innerList.Add(New CountryInfo("Paraguay", 406750, 6347900))
        _innerList.Add(New CountryInfo("Peru", 1285220, 27925600))
        _innerList.Add(New CountryInfo("Philippines", 300000, 87857500))
        _innerList.Add(New CountryInfo("Pitcairn", 47, 46))
        _innerList.Add(New CountryInfo("Poland", 312685, 38635100))
        _innerList.Add(New CountryInfo("Portugal", 92391, 10566200))
        _innerList.Add(New CountryInfo("Puerto Rico", 9104, 3916600))
        _innerList.Add(New CountryInfo("Qatar", 11437, 863100))
        _innerList.Add(New CountryInfo("Reunion", 2517, 776900))
        _innerList.Add(New CountryInfo("Romania", 237500, 22330000))
        _innerList.Add(New CountryInfo("Russia", 17075200, 143420300))
        _innerList.Add(New CountryInfo("Rwanda", 26338, 8440800))
        _innerList.Add(New CountryInfo("Saint Helena", 410, 7460))
        _innerList.Add(New CountryInfo("Saint Kitts & Nevis", 261, 38960))
        _innerList.Add(New CountryInfo("Saint Lucia", 616, 166300))
        _innerList.Add(New CountryInfo("Saint Pierre & Miquelon", 242, 7010))
        _innerList.Add(New CountryInfo("Saint Vincent (& the Grenadines)", 389, 117500))
        _innerList.Add(New CountryInfo("Samoa", 2944, 177300))
        _innerList.Add(New CountryInfo("San Marino", 61, 28880))
        _innerList.Add(New CountryInfo("Sao Tome & Principe", 1001, 187400))
        _innerList.Add(New CountryInfo("Saudi Arabia", 1960582, 26417600))
        _innerList.Add(New CountryInfo("Senegal", 196190, 11126800))
        _innerList.Add(New CountryInfo("Serbia & Montenegro", 102350, 10829200))
        _innerList.Add(New CountryInfo("Seychelles", 455, 81190))
        _innerList.Add(New CountryInfo("Sierra Leone", 71740, 6017600))
        _innerList.Add(New CountryInfo("Singapore", 693, 4425700))
        _innerList.Add(New CountryInfo("Slovakia", 48845, 5431400))
        _innerList.Add(New CountryInfo("Slovenia", 20273, 2011100))
        _innerList.Add(New CountryInfo("Solomon Islands", 28450, 538000))
        _innerList.Add(New CountryInfo("Somalia", 637657, 8591600))
        _innerList.Add(New CountryInfo("South Africa", 1219912, 44344100))
        _innerList.Add(New CountryInfo("Spain", 504782, 40341500))
        _innerList.Add(New CountryInfo("Sri Lanka", 65610, 20064800))
        _innerList.Add(New CountryInfo("Sudan", 2505810, 40187500))
        _innerList.Add(New CountryInfo("Suriname", 163270, 438100))
        _innerList.Add(New CountryInfo("Svalbard", 62049, 2700))
        _innerList.Add(New CountryInfo("Swaziland", 17363, 1173900))
        _innerList.Add(New CountryInfo("Sweden", 449964, 9001800))
        _innerList.Add(New CountryInfo("Switzerland", 41290, 7489400))
        _innerList.Add(New CountryInfo("Syria", 185180, 18448800))
        _innerList.Add(New CountryInfo("Taiwan (Republic of China)", 35980, 22894400))
        _innerList.Add(New CountryInfo("Tajikistan", 143100, 7163500))
        _innerList.Add(New CountryInfo("Tanzania", 945087, 36766400))
        _innerList.Add(New CountryInfo("Thailand", 514000, 65444400))
        _innerList.Add(New CountryInfo("Togo", 56785, 5681500))
        _innerList.Add(New CountryInfo("Tokelau", 10, 1410))
        _innerList.Add(New CountryInfo("Tonga", 748, 112400))
        _innerList.Add(New CountryInfo("Trinidad & Tobago", 5128, 1088600))
        _innerList.Add(New CountryInfo("Tunisia", 163610, 10075000))
        _innerList.Add(New CountryInfo("Turkey", 780580, 69660600))
        _innerList.Add(New CountryInfo("Turkmenistan", 488100, 4952100))
        _innerList.Add(New CountryInfo("Turks & Caicos Islands", 430, 20560))
        _innerList.Add(New CountryInfo("Tuvalu", 26, 11640))
        _innerList.Add(New CountryInfo("Uganda", 236040, 27269500))
        _innerList.Add(New CountryInfo("Ukraine", 603700, 47425300))
        _innerList.Add(New CountryInfo("United Arab Emirates", 82880, 2563200))
        _innerList.Add(New CountryInfo("United States of America", 9629091, 295734100))
        _innerList.Add(New CountryInfo("Uruguay", 176220, 3415900))
        _innerList.Add(New CountryInfo("Uzbekistan", 447400, 26851200))
        _innerList.Add(New CountryInfo("Vanuatu", 12200, 205800))
        _innerList.Add(New CountryInfo("Vatican City", 1, 920))
        _innerList.Add(New CountryInfo("Venezuela", 912050, 25375300))
        _innerList.Add(New CountryInfo("Vietnam", 329560, 83535600))
        _innerList.Add(New CountryInfo("Virgin Islands of the US", 352, 108700))
        _innerList.Add(New CountryInfo("Wallis & Futuna", 274, 16030))
        _innerList.Add(New CountryInfo("Western Sahara", 266000, 273000))
        _innerList.Add(New CountryInfo("Yemen", 527970, 20727100))
        _innerList.Add(New CountryInfo("Zambia", 752614, 11261800))
        _innerList.Add(New CountryInfo("Zimbabwe", 390580, 12747000))
    End Sub

    Private Sub ICollection_CountryInfo_Add(ByVal item As CountryInfo) Implements System.Collections.Generic.ICollection(Of CountryInfo).Add
        _innerList.Add(item)
    End Sub

    Private Sub ICollection_CountryInfo_Clear() Implements System.Collections.Generic.ICollection(Of CountryInfo).Clear
        _innerList.Clear()
    End Sub

    Private Function ICollection_CountryInfo_Contains(ByVal item As CountryInfo) As Boolean Implements System.Collections.Generic.ICollection(Of CountryInfo).Contains
        Return _innerList.Contains(item)
    End Function

    Private Sub ICollection_CountryInfo_CopyTo(ByVal array() As CountryInfo, ByVal arrayIndex As Integer) Implements System.Collections.Generic.ICollection(Of CountryInfo).CopyTo
        _innerList.CopyTo(array, arrayIndex)
    End Sub

    Private ReadOnly Property ICollection_CountryInfo_Count() As Integer Implements System.Collections.Generic.ICollection(Of CountryInfo).Count
        Get
            Return _innerList.Count
        End Get
    End Property

    Private ReadOnly Property ICollection_CountryInfo_IsReadOnly() As Boolean Implements System.Collections.Generic.ICollection(Of CountryInfo).IsReadOnly
        Get
            Return CType(_innerList, ICollection(Of CountryInfo)).IsReadOnly
        End Get
    End Property

    Private Function ICollection_CountryInfo_Remove(ByVal item As CountryInfo) As Boolean Implements System.Collections.Generic.ICollection(Of CountryInfo).Remove
        Return _innerList.Remove(item)
    End Function

    Private Function IEnumerable_CountryInfo_GetEnumerator() As System.Collections.Generic.IEnumerator(Of CountryInfo) Implements System.Collections.Generic.IEnumerable(Of CountryInfo).GetEnumerator
        Return _innerList.GetEnumerator
    End Function

    Private Function IList_CountryInfo_IndexOf(ByVal item As CountryInfo) As Integer Implements System.Collections.Generic.IList(Of CountryInfo).IndexOf

    End Function

    Private Sub IList_CountryInfo_Insert(ByVal index As Integer, ByVal item As CountryInfo) Implements System.Collections.Generic.IList(Of CountryInfo).Insert

    End Sub

    Default Public Property Item(ByVal index As Integer) As CountryInfo Implements System.Collections.Generic.IList(Of CountryInfo).Item
        Get
            Return _innerList.Item(index)
        End Get
        Set(ByVal value As CountryInfo)
            _innerList.Item(index) = value
        End Set
    End Property

    Private Sub IList_CountryInfo_RemoveAt(ByVal index As Integer) Implements System.Collections.Generic.IList(Of CountryInfo).RemoveAt
        _innerList.RemoveAt(index)
    End Sub

    Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return _innerList.GetEnumerator
    End Function

    Private Sub ICollection_CopyTo(ByVal array As Array, ByVal index As Integer) Implements ICollection.CopyTo
        _innerList.CopyTo(array, index)
    End Sub

    Private ReadOnly Property ICollection_Count() As Integer Implements System.Collections.ICollection.Count
        Get
            Return _innerList.Count
        End Get
    End Property

    Private ReadOnly Property ICollection_IsSynchronized() As Boolean Implements System.Collections.ICollection.IsSynchronized
        Get
            Return CType(_innerList, ICollection).IsSynchronized
        End Get
    End Property

    Private ReadOnly Property ICollection_SyncRoot() As Object Implements System.Collections.ICollection.SyncRoot
        Get
            Return CType(_innerList, ICollection).SyncRoot
        End Get
    End Property

    Private Function IList_Add(ByVal value As Object) As Integer Implements System.Collections.IList.Add
        _innerList.Add(value)
    End Function

    Private Sub IList_Clear() Implements System.Collections.IList.Clear
        _innerList.Clear()
    End Sub

    Private Function IList_Contains(ByVal value As Object) As Boolean Implements System.Collections.IList.Contains
        Return _innerList.Contains(value)
    End Function

    Private Function IList_IndexOf(ByVal value As Object) As Integer Implements System.Collections.IList.IndexOf
        Return _innerList.IndexOf(value)
    End Function

    Private Sub IList_Insert(ByVal index As Integer, ByVal value As Object) Implements System.Collections.IList.Insert
        _innerList.Insert(index, value)
    End Sub

    Private ReadOnly Property IList_IsFixedSize() As Boolean Implements System.Collections.IList.IsFixedSize
        Get
            Return CType(_innerList, IList).IsFixedSize
        End Get
    End Property

    Private ReadOnly Property IList_IsReadOnly() As Boolean Implements System.Collections.IList.IsReadOnly
        Get
            Return CType(_innerList, IList).IsReadOnly
        End Get
    End Property

    Private Overloads Property IList_Item(ByVal index As Integer) As Object Implements System.Collections.IList.Item
        Get
            Return _innerList.Item(index)
        End Get
        Set(ByVal value As Object)
            _innerList.Item(index) = value
        End Set
    End Property

    Private Sub IList_Remove(ByVal value As Object) Implements System.Collections.IList.Remove
        _innerList.Remove(value)
    End Sub

    Private Sub IList_RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
        _innerList.RemoveAt(index)
    End Sub
End Class