Imports System.ComponentModel


Public Class Vote
    Implements INotifyPropertyChanged

    Public Sub New()

    End Sub

    Public Sub New(ByVal feature As Feature, ByVal year As Integer, ByVal priority As Integer)
        _feature = feature
        _year = year
        _priority = priority
    End Sub

    Private _feature As Feature
    Public Property Feature() As Feature
        Get
            Return _feature
        End Get
        Set(ByVal Value As Feature)
            _feature = Value
        End Set
    End Property

    Private _year As Integer
    Public Property Year() As Integer
        Get
            Return _year
        End Get
        Set(ByVal Value As Integer)
            _year = Value
        End Set
    End Property

    Private _priority As Integer
    Public Property Priority() As Integer
        Get
            Return _priority
        End Get
        Set(ByVal Value As Integer)
            _priority = Value
            RaisePropertyChanged("Priority")
        End Set
    End Property

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Public Sub RaisePropertyChanged(ByVal propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub

End Class
