Imports System.ComponentModel


Public Class VoteValueColumn
    Inherits DataGridViewColumn

    Public Sub New()
        MyBase.New(New VoteValueCell)
    End Sub

    Public Overrides Property CellTemplate() As System.Windows.Forms.DataGridViewCell
        Get
            Return MyBase.CellTemplate
        End Get
        Set(ByVal value As System.Windows.Forms.DataGridViewCell)
            If value IsNot Nothing AndAlso Not (value.GetType.IsAssignableFrom(GetType(VoteValueCell))) Then
                Throw New InvalidCastException("Cell must be of type VoteValueCell")
            End If
            MyBase.CellTemplate = value
        End Set
    End Property
End Class
