Imports System.ComponentModel


Public Class TypedListWrapperIListT(Of T)
    Inherits TypedListWrapperIList
    Implements IList(Of T)

    Public Sub New()

    End Sub

    Public Sub New(ByVal wrapperIListT As IList(Of T))
        _wrapperIListT = wrapperIListT
    End Sub

    Public Sub New(ByVal wrapperIListT As IList(Of T), ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
        _wrapperIListT = wrapperIListT
    End Sub

    Public Sub New(ByVal _propertyDescriptorCollection As PropertyDescriptorCollection)
        MyBase.New(_propertyDescriptorCollection)
    End Sub

    Private _wrapperIListT As IList(Of T)
    Public Property WrapperIListT() As IList(Of T)
        Get
            Return _wrapperIListT
        End Get
        Set(ByVal Value As IList(Of T))
            _wrapperIListT = Value
        End Set
    End Property

    Private Sub ICollectionT_Add(ByVal item As T) Implements System.Collections.Generic.ICollection(Of T).Add
        _wrapperIListT.Add(item)
    End Sub

    Private Sub ICollectionT_Clear() Implements System.Collections.Generic.ICollection(Of T).Clear
        _wrapperIListT.Clear()
    End Sub

    Private Function ICollectionT_Contains(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Contains
        Return _wrapperIListT.Contains(item)
    End Function

    Private Sub ICollectionT_CopyTo(ByVal array() As T, ByVal arrayIndex As Integer) Implements System.Collections.Generic.ICollection(Of T).CopyTo
        _wrapperIListT.CopyTo(array, arrayIndex)
    End Sub

    Private ReadOnly Property ICollectionT_Count() As Integer Implements System.Collections.Generic.ICollection(Of T).Count
        Get
            Return _wrapperIListT.Count
        End Get
    End Property

    Private ReadOnly Property ICollectionT_IsReadOnly() As Boolean Implements System.Collections.Generic.ICollection(Of T).IsReadOnly
        Get
            Return _wrapperIListT.IsReadOnly
        End Get
    End Property

    Private Function ICollectionT_Remove(ByVal item As T) As Boolean Implements System.Collections.Generic.ICollection(Of T).Remove
        Return _wrapperIListT.Remove(item)
    End Function

    Private Function IEnumerableT_GetEnumerator() As System.Collections.Generic.IEnumerator(Of T) Implements System.Collections.Generic.IEnumerable(Of T).GetEnumerator
        Return _wrapperIListT.GetEnumerator
    End Function

    Private Function IListT_IndexOf(ByVal item As T) As Integer Implements System.Collections.Generic.IList(Of T).IndexOf
        Return _wrapperIListT.IndexOf(item)
    End Function

    Private Sub IListT_Insert(ByVal index As Integer, ByVal item As T) Implements System.Collections.Generic.IList(Of T).Insert
        _wrapperIListT.Insert(index, item)
    End Sub

    Private Property IListT_Item(ByVal index As Integer) As T Implements System.Collections.Generic.IList(Of T).Item
        Get
            Return _wrapperIListT.Item(index)
        End Get
        Set(ByVal value As T)
            _wrapperIListT.Item(index) = value
        End Set
    End Property

    Private Sub IListT_RemoveAt(ByVal index As Integer) Implements System.Collections.Generic.IList(Of T).RemoveAt
        _wrapperIListT.RemoveAt(index)
    End Sub
End Class
