Imports DemoData

Public Class Form1

    Public Sub New()
        InitializeComponent()

        DataGridView1.RowCount = CType(CountryInfoList1, IList).Count + 1
    End Sub

    Private Sub DataGridView1_CellValueNeeded(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellValueEventArgs) Handles DataGridView1.CellValueNeeded
        Dim _countryInfo As CountryInfo = CountryInfoList1(e.RowIndex)

        If e.ColumnIndex = NameColumn.Index Then
            e.Value = _countryInfo.Name
        ElseIf e.ColumnIndex = PopulationColumn.Index Then
            e.Value = _countryInfo.Population
        ElseIf e.ColumnIndex = AreaKM2Column.Index Then
            e.Value = _countryInfo.AreaKM2
        End If
    End Sub

    Private Sub DataGridView1_CellValuePushed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellValueEventArgs) Handles DataGridView1.CellValuePushed
        Dim _countryInfo As CountryInfo = CountryInfoList1(e.RowIndex)

        If e.ColumnIndex = NameColumn.Index Then
            _countryInfo.Name = CStr(e.Value)
        ElseIf e.ColumnIndex = PopulationColumn.Index Then
            _countryInfo.Population = CInt(e.Value)
        ElseIf e.ColumnIndex = AreaKM2Column.Index Then
            _countryInfo.AreaKM2 = CInt(e.Value)
        End If
    End Sub
End Class
